/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GuidJsonPatchDocumentValueTuple type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GuidJsonPatchDocumentValueTuple{}

// GuidJsonPatchDocumentValueTuple struct for GuidJsonPatchDocumentValueTuple
type GuidJsonPatchDocumentValueTuple struct {
	Item1 *string            `json:"item1,omitempty"`
	Item2 *JsonPatchDocument `json:"item2,omitempty"`
}

// NewGuidJsonPatchDocumentValueTuple instantiates a new GuidJsonPatchDocumentValueTuple object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGuidJsonPatchDocumentValueTuple() *GuidJsonPatchDocumentValueTuple {
	this := GuidJsonPatchDocumentValueTuple{}
	return &this
}

// NewGuidJsonPatchDocumentValueTupleWithDefaults instantiates a new GuidJsonPatchDocumentValueTuple object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGuidJsonPatchDocumentValueTupleWithDefaults() *GuidJsonPatchDocumentValueTuple {
	this := GuidJsonPatchDocumentValueTuple{}
	return &this
}

// GetItem1 returns the Item1 field value if set, zero value otherwise.
func (o *GuidJsonPatchDocumentValueTuple) GetItem1() string {
	if o == nil || IsNil(o.Item1) {
		var ret string
		return ret
	}
	return *o.Item1
}

// GetItem1Ok returns a tuple with the Item1 field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GuidJsonPatchDocumentValueTuple) GetItem1Ok() (*string, bool) {
	if o == nil || IsNil(o.Item1) {
		return nil, false
	}
	return o.Item1, true
}

// HasItem1 returns a boolean if a field has been set.
func (o *GuidJsonPatchDocumentValueTuple) HasItem1() bool {
	if o != nil && !IsNil(o.Item1) {
		return true
	}

	return false
}

// SetItem1 gets a reference to the given string and assigns it to the Item1 field.
func (o *GuidJsonPatchDocumentValueTuple) SetItem1(v string) {
	o.Item1 = &v
}

// GetItem2 returns the Item2 field value if set, zero value otherwise.
func (o *GuidJsonPatchDocumentValueTuple) GetItem2() JsonPatchDocument {
	if o == nil || IsNil(o.Item2) {
		var ret JsonPatchDocument
		return ret
	}
	return *o.Item2
}

// GetItem2Ok returns a tuple with the Item2 field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GuidJsonPatchDocumentValueTuple) GetItem2Ok() (*JsonPatchDocument, bool) {
	if o == nil || IsNil(o.Item2) {
		return nil, false
	}
	return o.Item2, true
}

// HasItem2 returns a boolean if a field has been set.
func (o *GuidJsonPatchDocumentValueTuple) HasItem2() bool {
	if o != nil && !IsNil(o.Item2) {
		return true
	}

	return false
}

// SetItem2 gets a reference to the given JsonPatchDocument and assigns it to the Item2 field.
func (o *GuidJsonPatchDocumentValueTuple) SetItem2(v JsonPatchDocument) {
	o.Item2 = &v
}

func (o GuidJsonPatchDocumentValueTuple) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GuidJsonPatchDocumentValueTuple) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Item1) {
		toSerialize["item1"] = o.Item1
	}
	if !IsNil(o.Item2) {
		toSerialize["item2"] = o.Item2
	}
	return toSerialize, nil
}

type NullableGuidJsonPatchDocumentValueTuple struct {
	value *GuidJsonPatchDocumentValueTuple
	isSet bool
}

func (v NullableGuidJsonPatchDocumentValueTuple) Get() *GuidJsonPatchDocumentValueTuple {
	return v.value
}

func (v *NullableGuidJsonPatchDocumentValueTuple) Set(val *GuidJsonPatchDocumentValueTuple) {
	v.value = val
	v.isSet = true
}

func (v NullableGuidJsonPatchDocumentValueTuple) IsSet() bool {
	return v.isSet
}

func (v *NullableGuidJsonPatchDocumentValueTuple) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGuidJsonPatchDocumentValueTuple(val *GuidJsonPatchDocumentValueTuple) *NullableGuidJsonPatchDocumentValueTuple {
	return &NullableGuidJsonPatchDocumentValueTuple{value: val, isSet: true}
}

func (v NullableGuidJsonPatchDocumentValueTuple) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGuidJsonPatchDocumentValueTuple) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
